require "util"

script.on_event(
  defines.events.on_tick,
  function(event)
    OnTick(event)
  end
)

script.on_event({
    defines.events.on_built_entity, 
    defines.events.on_robot_built_entity
  },
  function(event)
    OnPlaced(event)
  end
)

script.on_event({
    defines.events.on_preplayer_mined_item, 
    defines.events.on_robot_pre_mined, 
    defines.events.on_entity_died
  }, 
  function(event)
    OnRemoved(event)
  end
)

function OnPlaced(event)
  if event.created_entity.name == "items-generator" then
    AddEntityToGlobalList(event.created_entity)
  end
end

function OnRemoved(event)
end

function AddEntityToGlobalList(entity)
  if global.Items_Generators == nil then
    global.Items_Generators = {}
  end
  local items_generator = entity
  table.insert(global.Items_Generators, items_generator)
end

function OnTick(event)
	if global.Items_Generators ~= nil then 
		for i = #global.Items_Generators,1,-1 do
      local items_generator = global.Items_Generators[i]
			if items_generator.valid then
        for j = 1, items_generator.request_slot_count, 1 do
          local requested_item_stack = items_generator.get_request_slot(j)
          if requested_item_stack ~= nil then
            local inventory = items_generator.get_inventory(defines.inventory.chest)
            local amount = inventory.get_item_count(requested_item_stack.name)
            if amount < requested_item_stack.count then
              local item_stack_to_insert = {name = requested_item_stack.name, count = requested_item_stack.count - amount}
              items_generator.insert(item_stack_to_insert)
            end
          end
        end
			else --items_generator.valid == false
        table.remove(global.Items_Generators, i)
      end
		end
	end
end
